import 'dart:convert';
import 'dart:isolate';
import 'dart:ui';

import 'package:awesome_notifications/awesome_notifications.dart';
import 'package:feedify/feedsdk.dart';
import 'package:feedify/src/manager/feed_api_manager.dart';
import 'package:feedify/src/model/notification/model_notification.dart';
import 'package:feedify/src/utils/notification_util.dart';
import 'package:flutter/material.dart';
import 'package:url_launcher/url_launcher.dart';

import '../../const.dart';
import '../../logs.dart';
import '../storage/app-prefs.dart';

class NotificationManager {
  static final NotificationManager _singleton = NotificationManager._internal();
 static Button1? _button1;
  static Button2? _button2;
  static ReceivedAction? initialAction;

  static AppPreferences prefs = AppPreferences();

  NotificationManager._internal();

  static NotificationManager getInstance() {
    return _singleton;
  }

  void init(Function(Map<String, String?>)? notificationDataCallback) async {
    await _initialiseNotifications();
    await  initializeIsolateReceivePort();
    _initialiseNotificationsClick(notificationDataCallback);
  }

  Future<bool> _initialiseNotifications2() async {


    // Get initial notification action is optional
    initialAction = await AwesomeNotifications()
        .getInitialNotificationAction(removeFromActionEvents: false);

    return await AwesomeNotifications().initialize(
      FeedSDK.notificationIco,
      [
        NotificationChannel(
            importance: NotificationImportance.High,
            channelGroupKey: 'FEEDIFY_CHANNEL',
            channelKey: 'basic_channel',
            channelName: 'FEEDIFY_CHANNEL',
            channelDescription: 'Feed notification channel.',
            defaultColor: Colors.white,
            channelShowBadge: true,
            ledColor: Colors.white)
      ],
      debug: true,
    );

  }


  ///  *********************************************
  ///     INITIALIZATIONS
  ///  *********************************************
  ///
   Future<void> _initialiseNotifications() async {
    await AwesomeNotifications().initialize(
        FeedSDK.notificationIco,
         //'resource://drawable/res_app_icon',//
        [
          NotificationChannel(
              importance: NotificationImportance.High,
              channelGroupKey: 'FEEDIFY_CHANNEL',
              channelKey: 'basic_channel',
              channelName: 'FEEDIFY_CHANNEL',
              channelDescription: 'Feed notification channel.',
              defaultColor: Colors.white,
              channelShowBadge: true,
              ledColor: Colors.white)
        ],
        debug: true);

    // Get initial notification action is optional
    initialAction = await AwesomeNotifications()
        .getInitialNotificationAction(removeFromActionEvents: false);
  }





 static Function(Map<String, String?>)? notificationDataCallback ;
  void _initialiseNotificationsClick(
      Function(Map<String, String?>)? notificationDataCallback) {

    NotificationManager.notificationDataCallback = notificationDataCallback;

    AwesomeNotifications().setListeners(
        onActionReceivedMethod: onActionReceivedMethod);
  }


 /* void _initialiseNotificationsClick(
      Function(Map<String, String?>)? notificationDataCallback) {
    AwesomeNotifications().setListeners(
        onActionReceivedMethod: onActionReceivedMethod);
  }*/
  



  ///  *********************************************
  ///     NOTIFICATION EVENTS
  ///  *********************************************
  ///
  @pragma('vm:entry-point')
  static Future<void> onActionReceivedMethod(
      ReceivedAction receivedAction) async {


    print(receivedAction.actionType);

    if (receivedAction.actionType == ActionType.SilentAction ||
        receivedAction.actionType == ActionType.SilentBackgroundAction) {
      // For background actions, you must hold the execution until the end
      print(
          'Message sent via notification input: "${receivedAction.buttonKeyInput}"');
      // await executeLongTaskInBackground();
    } else {
      // this process is only necessary when you need to redirect the user
      // to a new page or use a valid context, since parallel isolates do not
      // have valid context, so you need redirect the execution to main isolate
      if (receivePort == null) {
        print(
            'onActionReceivedMethod was called inside a parallel dart isolate.');
        SendPort? sendPort =
        IsolateNameServer.lookupPortByName('notification_action_port');

        if (sendPort != null) {
          print('Redirecting the execution to main isolate process.');
          sendPort.send(receivedAction);
          return;
        }
      }

      return onActionReceivedImplementationMethod(receivedAction);
    }
  }


  static ReceivePort? receivePort;
  static Future<void> initializeIsolateReceivePort() async {
    receivePort = ReceivePort('Notification action port in main isolate')
      ..listen(
              (silentData) => onActionReceivedImplementationMethod(silentData));

    // This initialization only happens on main isolate
    IsolateNameServer.registerPortWithName(
        receivePort!.sendPort, 'notification_action_port');
  }




  static Future<void> onActionReceivedImplementationMethod(
      ReceivedAction receivedAction) async {


    print('Hello 33333');

    //Fluttertoast.showToast(msg: "msg ${ receivedAction.actionType}");
    /*SharedPreferences.getInstance().then((obj) {


      print( json.encode(receivedAction.toMap()))  ;
      obj.clear();
      obj.setString("json_key",  json.encode(receivedAction.toMap()));
    });*/

    Logs.d(
        'Notification clicked id ::  ${receivedAction.id}, button pressed::  ${receivedAction.buttonKeyPressed}');
    var map = receivedAction.payload;
    if (map != null) {
      if (map[Constants.type] == 'ad') {
        _launchURL(map[Constants.url]);
      } else {
        if (true) {
          // handle it here



          if (receivedAction.buttonKeyPressed.isEmpty) {
            // clicked on notification part not on buttons
            _launchURL(map[Constants.url]);
          } else {

            if(_button1?.title != null && _button2?.title != null){

              if (receivedAction.buttonKeyPressed == _button1?.title) {
                _launchURL(_button1?.action);
              } else if (receivedAction.buttonKeyPressed == _button2?.title) {
                _launchURL(_button2?.action);
              }
            }else{

              try{




                var map =  json.encode(receivedAction.toMap());

                var map2 =  jsonDecode(map);


                var button1Action= map2['payload']['button1Action'] ;
                var button2action= map2['payload']['button2action'] ;
                var button2title= map2['payload']['button2title'] ;
                var button1title= map2['payload']['button1title'] ;

                print(button1Action);
                print(button2action);
                print(button2title);
                print(button1title);


               // var modelNotification =   ModelNotification.fromJson(map2);



                if (receivedAction.buttonKeyPressed == button1title) {
                  _launchURL(button1Action);
                } else if (receivedAction.buttonKeyPressed == button2title) {
                  _launchURL(button2action);
                }

             //   print('finally ${model.title}');

              }catch(e){
                print('finally ${e}');
              }
            }


          }
        } else {
          Map<String, String?> data = await prefs.getNotificationsData();
          NotificationUtils.notificationPayloadKeys.clear();
          notificationDataCallback?.call(data);
        }
      }
      _callClickApi(map);
    }

    /* MyApp.navigatorKey.currentState?.pushNamedAndRemoveUntil(
        '/notification-page',
            (route) =>
        (route.settings.name != '/notification-page') || route.isFirst,
        arguments: receivedAction);*/
  }
 void _initialiseNotificationsClick2(
      Function(Map<String, String?>)? notificationDataCallback) {
    AwesomeNotifications().setListeners(
        onActionReceivedMethod: (ReceivedAction receivedAction) async {
          Logs.d(
              'Notification clicked id ::  ${receivedAction.id}, button pressed::  ${receivedAction.buttonKeyPressed}');
          var map = receivedAction.payload;
          if (map != null) {
            if (map[Constants.type] == 'ad') {
              _launchURL(map[Constants.url]);
            } else {
              if (notificationDataCallback == null) {
                // handle it here
                if (receivedAction.buttonKeyPressed.isEmpty) {
                  // clicked on notification part not on buttons
                  _launchURL(map[Constants.url]);
                } else {
                  if (receivedAction.buttonKeyPressed == _button1?.title) {
                    _launchURL(_button1?.action);
                  } else if (receivedAction.buttonKeyPressed == _button2?.title) {
                    _launchURL(_button2?.action);
                  }
                }
              } else {
                Map<String, String?> data = await prefs.getNotificationsData();
                NotificationUtils.notificationPayloadKeys.clear();
                notificationDataCallback.call(data);
              }
            }
            _callClickApi(map);
          }
        });
  }



  void showNotification(final ModelNotification notificationData) {
    Logs.d('Notification clicked notificationData ::  $notificationData');
    if (notificationData.id != null &&
        notificationData.id?.isNotEmpty == true) {
      bool isBigPicture = false;
      if (notificationData.image != null &&
          notificationData.image!.isNotEmpty) {
        isBigPicture = true;
      }
      AwesomeNotifications().createNotification(
        content: NotificationContent(
          notificationLayout: isBigPicture
              ? NotificationLayout.BigPicture
              : NotificationLayout.BigText,
          id: int.parse(notificationData.id!),
          channelKey: 'basic_channel',
          title: notificationData.title,
          icon: "resource://drawable/res_app_icon",
          body: notificationData.body,
          autoDismissible: true,
          largeIcon: notificationData.icon,
          bigPicture: notificationData.image,
          payload: NotificationUtils.getInstance()
              .getNotificationData(notificationData),
        ),
        actionButtons: _getActionButtons(notificationData),
      );
    }
  }

  List<NotificationActionButton> _getActionButtons(
      ModelNotification notificationData) {
    List<NotificationActionButton> actionButtons = [];
    _button1 = notificationData.button?.button1;
    _button2 = notificationData.button?.button2;

    if (_button1 != null && _button2 != null) {
      if (_button1?.title?.isNotEmpty == true) {
        NotificationActionButton actionButton = NotificationActionButton(
            key: _button1!.title!,
            label: _button1!.title!,
            icon: _button1!.icon,
            autoDismissible: true,
            actionType: ActionType.Default);
        actionButtons.add(actionButton);
      }
      if (_button2?.title?.isNotEmpty == true) {
        NotificationActionButton actionButton = NotificationActionButton(
            key: _button2!.title!,
            label: _button2!.title!,
            icon: _button2!.icon,
            autoDismissible: true,
            actionType: ActionType.Default);
        actionButtons.add(actionButton);
      }
    }
    return actionButtons;
  }

  static void _launchURL(String? url) async {
    if (url != null) {
      if (!url.startsWith('http')) {
        url = 'http://' + url;
      }
      url = Uri.encodeFull(url);
      if (await canLaunch(url)) {
        await launch(url);
      } else {
        Logs.d('Could not launch $url');
      }
    } else {
      Logs.d('Could not launch $url');
    }
  }

 static void _callClickApi(Map<String, String?> map) {
    var type = map[Constants.type];
    var notificationId = map[Constants.notificationId];

    if (type != null &&
        type.isNotEmpty == true &&
        notificationId != null &&
        notificationId.isNotEmpty == true) {
      FeedApiManager.getInstance()
          .callClickApi(map[Constants.type]!, map[Constants.notificationId]!);
    }
  }
}
